"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
function mapResponse(res) {
    if (res.status >= 400) {
        throw new ApiError('Bad status code', res);
    }
    var responseBody = res.json();
    if (responseBody.status !== undefined && responseBody.status !== 1) {
        throw new ApiError('Error response received', responseBody);
    }
    return responseBody;
}
exports.mapResponse = mapResponse;
var ApiError = (function (_super) {
    __extends(ApiError, _super);
    function ApiError(message, response) {
        _super.call(this);
        this.response = response;
        this.message = message;
        this.stack = new Error().stack;
    }
    ;
    return ApiError;
}(Error));
exports.ApiError = ApiError;
//# sourceMappingURL=response-mapper.js.map