import { ApiService } from './api';
import { MockBackend } from '@angular/http/testing';
import { BaseRequestOptions, Http, RequestMethod } from '@angular/http';
export interface ResponseExpectation {
    path: string;
    method: RequestMethod;
    body?: Object;
    headers?: Object;
}
export declare function setupProviders(): (typeof BaseRequestOptions | typeof MockBackend | {
    provide: typeof ApiService;
    deps: typeof Http[];
    useFactory: (http: any, config: any) => ApiService;
} | {
    provide: typeof Http;
    useFactory: (backend: any, options: any) => Http;
    deps: (typeof BaseRequestOptions | typeof MockBackend)[];
})[];
export declare class TestApi {
    private response;
    private error;
    private responseExpectation;
    constructor();
    respondWith(responseOpts?: any): this;
    respondWithError(error: Error): this;
    expect(responseExpectation: ResponseExpectation): this;
    private methodMatchFailMessage(actualMethod);
    test(t: (api: ApiService) => void): (done: any) => any;
}
