import { Http } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { AuthorisationTokens } from './authorisation-tokens';
export declare class AuthenticationError extends Error {
    constructor(options: {
        missingToken?: boolean;
        expiredToken?: boolean;
        badToken?: boolean;
    });
}
export interface AuthTokensValidator {
    validateTokens(authToken: string, refreshToken: string): Observable<AuthorisationTokens>;
}
export declare class JwtAuthTokensValidator implements AuthTokensValidator {
    private http;
    private refreshAuthTokenService;
    constructor(http: Http, apiBaseUrl: string);
    validateTokens(authToken: string, refreshToken: string): Observable<AuthorisationTokens>;
    private isAuthTokenValid(token);
}
