"use strict";
var Rx_1 = require('rxjs/Rx');
var TokenStore = (function () {
    function TokenStore() {
        this.authTokenKey = 'authToken';
        this.refreshTokenKey = 'refreshToken';
        this.events = new Rx_1.Subject();
    }
    TokenStore.prototype.get = function () {
        return Rx_1.Observable.from([{
                authToken: localStorage.getItem(this.authTokenKey),
                refreshToken: localStorage.getItem(this.refreshTokenKey)
            }]);
    };
    TokenStore.prototype.save = function (authToken, refreshToken) {
        localStorage.setItem(this.authTokenKey, authToken);
        localStorage.setItem(this.refreshTokenKey, refreshToken);
    };
    TokenStore.prototype.clear = function () {
        localStorage.removeItem(this.authTokenKey);
        localStorage.removeItem(this.refreshTokenKey);
    };
    return TokenStore;
}());
exports.TokenStore = TokenStore;
//# sourceMappingURL=token-store.js.map